' 

FUNCTION mtopb(fname$) as STRING

    LOCAL fl   as DWORD

    Open fname$ for Binary as #1
      fl = lof(1)
      Get$ #1,fl,a$
    Close #1

    Replace ";" With "'" in a$      ' convert comments to basic
    Replace chr$(9) with " " in a$  ' replace each tab with a space

    Open "tempfile.ext" for Output as #1
      Print #1, a$;
    Close #1

    Open "tempfile.ext" for Input as #1

    fname$ = lcase$(fname$)
    Replace ".asm" with ".bas" in fname$
    fname$ = NameFromPath(fname$)

    Open fname$ for Output as #2
    Do
      Line Input #1, a$
      ' -----------------------------------------------
      ' use the first word on the line as the test word
      ' -----------------------------------------------
        tstw$ = parse$(ltrim$(a$)," ",1)

        Select Case tstw$
          Case "ret"
            Replace "ret" With "! mov FUNCTION, eax" in a$
            a$ = a$ + chr$(13,10) + "    Exit FUNCTION"
            ! jmp printit
          Case ".model"
            ! jmp pastit
          Case "db"
            a$ = "    ! "+ltrim$(a$)
            ! jmp printit
          Case "dw"
            a$ = "    ! "+ltrim$(a$)
            ! jmp printit
          Case "dd"
            a$ = "    ! "+ltrim$(a$)
            ! jmp printit
          Case "LOCAL"
          ' -----------------------------------------------------------
          ' If there is no repeat count in MASM data type IE: [260]
          ' replace the ":" with " as " and print it.
          ' -----------------------------------------------------------
            If instr(a$,"[") = 0 and instr(a$,"]") = 0 Then
              Replace ":" With " as " in a$
              ! jmp printit
            End If
          ' -----------------------------------------------------------
          ' convert MASM stack arrays to basic's STRING * number format
          ' -----------------------------------------------------------
            num& = val(mid$(a$,instr(a$,"[")+1))
            lft$ = left$(a$,instr(a$,"[")-1)
            If instr(lcase$(a$),"byte") Then
              a$ = lft$+" as STRING *"+str$(num&)
              ! jmp printit
            End If

            If instr(lcase$(a$),"dword") Then
              a$ = lft$+" as STRING *"+str$(num&*4)
              ! jmp printit
            End If

            If instr(lcase$(a$),"word") Then
              a$ = lft$+" as STRING *"+str$(num&*2)
              ! jmp printit
            End If
          ' -----------------------------------------------------------
        End Select

        If ismnemonic(lcase$(tstw$)) Then   ' test if word is asm mnemonic
          a$ = "    ! "+ltrim$(a$)
          ! jmp printit
        End If

        If right$(tstw$,1) = ":" Then       ' test if word is a label
        ! jmp printit
        End If

        If left$(tstw$,1) = "'" Then        ' test if line is a comment line
        ! jmp printit
        End If

        If trim$(a$) = "" Then              ' test if blank line
        ! jmp printit
        End If

        If instr(lcase$(a$)," endp") <> 0 Then
          a$ = "END FUNCTION"
          ! jmp printit
        End If

        If instr(lcase$(a$)," proc") <> 0 Then
        ' ------------------------------------------
        ' handle split line in procedure declaration
        ' ------------------------------------------
          tryagain:
          If right$(trim$(a$),1) = "," Then
            Line Input #1, b$
            a$ = a$ + trim$(b$)
            If right$(trim$(a$),1) = "," Then
              ! jmp tryagain
            End If
          End If
        ' ------------------------------------------
          a$ = "FUNCTION "+a$
          Replace " proc" With "(" in a$
          Replace "( " With "(ByVal " in a$
          Replace "," With ",ByVal " in a$
          Replace ":" With " as " in a$
          Replace " )" With ")" in a$
          a$ = a$ + ") as DWORD"+chr$(13,10,13,10)+"    #REGISTER NONE"
          ! jmp printit
        End If

        a$ = " ' "+a$   ' comment out anything else

      printit:
        Print #2, a$
      pastit:

    Loop while not eof(1)
    Close #2
    Close #1

    kill "tempfile.ext"

    FUNCTION = a$

END FUNCTION

' 

FUNCTION NameFromPath(fname$) as STRING

    #REGISTER NONE

    LOCAL var as LONG
    LOCAL ln  as LONG

    ln  = len(fname$)
    ! mov esi, fname$
    ! mov esi, [esi]    ; dereference ESI

    ! xor ecx, ecx      ; zero ECX to use as location counter
    ! mov edx, ln
    ! add edx, esi      ; exit test condition in EDX

  lbl1:
    ! mov al, [esi]     ; character in AL for comparison
    ! inc esi           ; increment pointer
    ! inc ecx           ; increment location counter
    ! cmp al, "\"
    ! je nxt1
    ! cmp al, "/"
    ! je nxt1
    ! cmp edx, esi
    ! jne lbl1
    ! jmp qit

  nxt1:
    ! mov edi, ecx      ; put each "\" position in EDI
    ! cmp edx, esi
    ! jne lbl1

  qit:
    ! sub ln, edi       ; sub last "\" position from length of string

    FUNCTION = right$(fname$,ln)

END FUNCTION

' 

FUNCTION Exist(fname$) as LONG
  FUNCTION = Len( Dir$(fname$, 17) ) > 0
END FUNCTION

' 
